=== debian/watch ===
version=3

http://sf.net/duma/duma-(.*)\.tar\.gz
