=== debian/changelog ===
duma (2.5.21-8) unstable; urgency=medium

  * Copyright fixes
  * Add licenserecon to salsa CI

 -- Peter Blackman <peter@pblackman.plus.com>  Wed, 03 Jan 2024 17:00:00 +0000

duma (2.5.21-7) unstable; urgency=medium

  * Forward patches & update headers
  * Standards version 4.6.2 (no change)
  * Update copyright

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 01 Dec 2023 11:00:00 +0000

duma (2.5.21-6) unstable; urgency=medium

  * Lintian overrides
  * Bump standards version (no change)

 -- Peter Blackman <peter@pblackman.plus.com>  Sun, 07 Aug 2022 14:00:00 +0100

duma (2.5.21-5) unstable; urgency=medium

  * Fix build unreproducible in armhf

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 05 Nov 2021 20:00:00 +0000

duma (2.5.21-4) unstable; urgency=medium

  * Fix watch file
  * Fix blhc warnings on kfreebsd
  * Set DDUMA_NO_STRERROR (needed for #623495)

 -- Peter Blackman <peter@pblackman.plus.com>  Mon, 18 Oct 2021 10:00:00 +0100

duma (2.5.21-3) unstable; urgency=medium

  * Add gbp.conf  {pristine-tar = True}
  * Check signing key in watch file
  * Fix blhc warnings re compiler flags

 -- Peter Blackman <peter@pblackman.plus.com>  Thu, 14 Oct 2021 16:00:00 +0100

duma (2.5.21-2) unstable; urgency=medium

  * Fix depends in autopkgtest

 -- Peter Blackman <peter@pblackman.plus.com>  Sat, 02 Oct 2021 14:00:00 +0100

duma (2.5.21-1) unstable; urgency=medium

  * Adopt package. (Closes: #565925)
  * New Upstream Release. (Closes: #550660, #623495, #655892)
  * Fixes FTBFS with GCC-11  (#984041)
  * Use hardening flags, fixes bindnow, (Closes: #532483)
  * Use changelog file date instead of system date for build date
  * DEP-5 copyright
  * Add autopkgtests
  * Preserve Debian's CFLAGS etc (use += , not just = , in makefile)
  * Override Lintian's library warnings
     The library is not intended to be used directly by other programs

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 01 Oct 2021 14:00:00 +0100

duma (2.5.15-3) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Use secure URI in debian/watch.
  * Set upstream metadata fields: Archive.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 22 Aug 2021 03:45:54 +0100
