=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: duma
 Section: devel
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends:
- debhelper-compat (= 12),
-Standards-Version: 3.8.1
-Homepage: http://duma.sf.net
+Maintainer: Peter Blackman <peter@pblackman.plus.com>
+Build-Depends: debhelper-compat (= 13)
+Rules-Requires-Root: no
+Standards-Version: 4.6.2
+Homepage: https://github.com/johnsonjh/duma
 Vcs-Browser: https://salsa.debian.org/debian/duma
 Vcs-Git: https://salsa.debian.org/debian/duma.git
 
 Package: duma
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: library to detect buffer overruns and under-runs in C and C++ programs
+Description: Detect Unintended Memory Access - A Red-Zone memory allocator
  Open-source library to detect buffer overruns and under-runs
  in C and C++ programs.
  .
