=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_HOST_ARCH

%:
# Build may break without --no-parallel
	dh $@ --no-parallel

# Wrong variable used for C++
override_dh_auto_build:
	  sed -i "s|CPPFLAGS|CXXFLAGS|"   GNUmakefile
	  dh_auto_build

override_dh_auto_clean:
	  sed -i "s|CXXFLAGS|CPPFLAGS|"   GNUmakefile
	  dh_auto_clean
