=== debian/tests/control ===
# Autopkgtests for duma
#
# Tests need object files form the build tree
# Use installed makefile, as patches may be needed

Test-Command: gmake -f /usr/share/duma/GNUmakefile check
Features: test-name=makefile-check
Depends: @, build-essential
Restrictions: build-needed, allow-stderr

Test-Command: gmake -f /usr/share/duma/GNUmakefile installcheck
Features: test-name=makefile-installcheck
Depends: @, make
Restrictions: build-needed, allow-stderr
